> For the complete documentation index, see [llms.txt](https://docs.defguard.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defguard.net/2.1/for-developers/rest-api/core/auth/finish-webauthn-registration.md).

# Finish WebAuthn registration

Applies to the user of the current session.

```json
{"openapi":"3.1.0","info":{"title":"defguard Core API","version":"2.1.0"},"tags":[{"name":"auth","description":"User authentication, second authentication factor and session management."}],"security":[{"cookie":[]},{"api_token":[]}],"components":{"securitySchemes":{"cookie":{"type":"apiKey","in":"cookie","name":"defguard_session"},"api_token":{"type":"http","scheme":"bearer"}},"schemas":{"WebAuthnRegistration":{"type":"object","required":["name","rpkc"],"properties":{"name":{"type":"string"},"rpkc":{"type":"object"}}},"RecoveryCodes":{"type":"object","properties":{"codes":{"type":["array","null"],"items":{"type":"string"}}}},"ApiErrorResponse":{"type":"object","description":"Body returned with error responses.","required":["msg"],"properties":{"code":{"type":["string","null"],"description":"Machine-readable error code, returned for selected errors."},"msg":{"type":"string","description":"Human-readable error message."}}}}},"paths":{"/api/v1/auth/webauthn/finish":{"post":{"tags":["auth"],"summary":"Finish WebAuthn registration","description":"Applies to the user of the current session.","operationId":"webauthn_finish","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/WebAuthnRegistration"}}},"required":true},"responses":{"200":{"description":"Security key registered. Returns recovery codes when this is the first configured factor.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RecoveryCodes"}}}},"400":{"description":"Invalid registration data.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"401":{"description":"Session is missing or invalid.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"500":{"description":"Unable to finish WebAuthn registration.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}}}}}}}
```
